diff --git a/amdgpu/meson.build b/amdgpu/meson.build
index a1781f59..6f6d679d 100644
--- a/amdgpu/meson.build
+++ b/amdgpu/meson.build
@@ -35,8 +35,7 @@ libdrm_amdgpu = shared_library(
     '-DAMDGPU_ASIC_ID_TABLE="@0@"'.format(join_paths(datadir_amdgpu, 'amdgpu.ids')),
   ],
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
-  dependencies : [dep_pthread_stubs, dep_atomic_ops],
+  dependencies : [dep_pthread_stubs, dep_atomic_ops, ext_libdrm],
   version : '1.0.0',
   install : true,
 )
@@ -53,7 +52,8 @@ pkg.generate(
 )
 
 ext_libdrm_amdgpu = declare_dependency(
-  link_with : [libdrm, libdrm_amdgpu],
+  link_with : [libdrm_amdgpu],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
diff --git a/etnaviv/meson.build b/etnaviv/meson.build
index 6040cf63..4ca28af7 100644
--- a/etnaviv/meson.build
+++ b/etnaviv/meson.build
@@ -29,9 +29,8 @@ libdrm_etnaviv = shared_library(
     config_file
   ],
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
   c_args : libdrm_c_args,
-  dependencies : [dep_pthread_stubs, dep_rt, dep_atomic_ops],
+  dependencies : [dep_pthread_stubs, dep_rt, dep_atomic_ops, ext_libdrm],
   version : '1.0.0',
   install : true,
 )
@@ -48,7 +47,8 @@ pkg.generate(
 )
 
 ext_libdrm_etnaviv = declare_dependency(
-  link_with : [libdrm, libdrm_etnaviv],
+  link_with : [libdrm_etnaviv],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
diff --git a/exynos/meson.build b/exynos/meson.build
index 40d66fc1..bd099ee3 100644
--- a/exynos/meson.build
+++ b/exynos/meson.build
@@ -23,8 +23,7 @@ libdrm_exynos = shared_library(
   [files('exynos_drm.c', 'exynos_fimg2d.c'), config_file],
   c_args : libdrm_c_args,
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
-  dependencies : [dep_pthread_stubs],
+  dependencies : [dep_pthread_stubs, ext_libdrm],
   version : '1.0.0',
   install : true,
 )
@@ -33,7 +32,8 @@ install_headers('exynos_drmif.h', subdir : 'libdrm')
 install_headers('exynos_drm.h', 'exynos_fimg2d.h', subdir : 'exynos')
 
 ext_libdrm_exynos = declare_dependency(
-  link_with : [libdrm, libdrm_exynos],
+  link_with : [libdrm_exynos],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
diff --git a/freedreno/meson.build b/freedreno/meson.build
index 63b84fc9..23525de1 100644
--- a/freedreno/meson.build
+++ b/freedreno/meson.build
@@ -44,14 +44,14 @@ libdrm_freedreno = shared_library(
   [files_freedreno, config_file],
   c_args : libdrm_c_args,
   include_directories : [inc_root, inc_drm],
-  dependencies : [dep_valgrind, dep_pthread_stubs, dep_rt, dep_atomic_ops],
-  link_with : libdrm,
+  dependencies : [dep_valgrind, dep_pthread_stubs, dep_rt, dep_atomic_ops, ext_libdrm],
   version : '1.0.0',
   install : true,
 )
 
 ext_libdrm_freedreno = declare_dependency(
-  link_with : [libdrm, libdrm_freedreno],
+  link_with : [libdrm_freedreno],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
diff --git a/intel/meson.build b/intel/meson.build
index 4d3f1ebd..cdc11772 100644
--- a/intel/meson.build
+++ b/intel/meson.build
@@ -28,15 +28,15 @@ libdrm_intel = shared_library(
     config_file,
   ],
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
-  dependencies : [dep_pciaccess, dep_pthread_stubs, dep_rt, dep_valgrind, dep_atomic_ops],
+  dependencies : [dep_pciaccess, dep_pthread_stubs, dep_rt, dep_valgrind, dep_atomic_ops, ext_libdrm],
   c_args : libdrm_c_args,
   version : '1.0.0',
   install : true,
 )
 
 ext_libdrm_intel = declare_dependency(
-  link_with : [libdrm, libdrm_intel],
+  link_with : [libdrm_intel],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
@@ -58,7 +58,8 @@ test_decode = executable(
   'test_decode',
   files('test_decode.c'),
   include_directories : [inc_root, inc_drm],
-  link_with : [libdrm, libdrm_intel],
+  link_with : [libdrm_intel],
+  dependencies : [ext_libdrm],
   c_args : libdrm_c_args,
 )
 
diff --git a/libkms/meson.build b/libkms/meson.build
index 216be4df..3f1ea2e1 100644
--- a/libkms/meson.build
+++ b/libkms/meson.build
@@ -46,13 +46,14 @@ libkms = shared_library(
   [files_libkms, config_file],
   c_args : libdrm_c_args,
   include_directories : libkms_include,
-  link_with : libdrm,
+  dependencies : [ext_libdrm],
   version : '1.0.0',
   install : true,
 )
 
 ext_libkms = declare_dependency(
-  link_with : [libdrm, libkms],
+  link_with : [libkms],
+  dependencies : [ext_libdrm],
   include_directories : [libkms_include],
 )
 
diff --git a/meson.build b/meson.build
index 831c8836..ab4bef19 100644
--- a/meson.build
+++ b/meson.build
@@ -304,6 +304,7 @@ add_project_arguments('-include', '@0@'.format(config_file), language : 'c')
 inc_root = include_directories('.')
 inc_drm = include_directories('include/drm')
 
+if get_option('libdrm') != 'false'
 libdrm = shared_library(
   'drm',
   [files(
@@ -333,11 +334,22 @@ ext_libdrm = declare_dependency(
   link_with : libdrm,
   include_directories : [inc_root, inc_drm],
 )
+else
+ext_libdrm = dependency('libdrm')
+endif
 
 install_headers('libsync.h', 'xf86drm.h', 'xf86drmMode.h')
+
+if get_option('libdrm') != 'false'
 install_headers(
   'include/drm/drm.h', 'include/drm/drm_fourcc.h', 'include/drm/drm_mode.h',
-  'include/drm/drm_sarea.h', 'include/drm/i915_drm.h',
+  'include/drm/drm_sarea.h',
+  subdir : 'libdrm',
+)
+endif
+
+install_headers(
+  'include/drm/i915_drm.h',
   'include/drm/mach64_drm.h', 'include/drm/mga_drm.h',
   'include/drm/msm_drm.h', 'include/drm/nouveau_drm.h',
   'include/drm/qxl_drm.h', 'include/drm/r128_drm.h',
@@ -351,6 +363,7 @@ if with_vmwgfx
   install_headers('include/drm/vmwgfx_drm.h', subdir : 'libdrm')
 endif
 
+if get_option('libdrm') != 'false'
 pkg.generate(
   name : 'libdrm',
   libraries : libdrm,
@@ -358,6 +371,7 @@ pkg.generate(
   version : meson.project_version(),
   description : 'Userspace interface to kernel DRM services',
 )
+endif
 
 if with_libkms
   subdir('libkms')
diff --git a/meson_options.txt b/meson_options.txt
index 8af33f1c..d431f69f 100644
--- a/meson_options.txt
+++ b/meson_options.txt
@@ -18,6 +18,14 @@
 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 # SOFTWARE.
 
+option(
+  'libdrm',
+  type : 'combo',
+  value : 'true',
+  choices : ['true', 'false'],
+  description : 'Build libdrm library.',
+)
+
 option(
   'libkms',
   type : 'combo',
diff --git a/nouveau/meson.build b/nouveau/meson.build
index 9bd58fca..55502361 100644
--- a/nouveau/meson.build
+++ b/nouveau/meson.build
@@ -24,14 +24,14 @@ libdrm_nouveau = shared_library(
   [files( 'nouveau.c', 'pushbuf.c', 'bufctx.c', 'abi16.c'), config_file],
   c_args : libdrm_c_args,
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
-  dependencies : [dep_threads, dep_atomic_ops],
+  dependencies : [dep_threads, dep_atomic_ops, ext_libdrm],
   version : '2.0.0',
   install : true,
 )
 
 ext_libdrm_nouveau = declare_dependency(
-  link_with : [libdrm, libdrm_nouveau],
+  link_with : [libdrm_nouveau],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
diff --git a/omap/meson.build b/omap/meson.build
index 53330b61..e8c67fd3 100644
--- a/omap/meson.build
+++ b/omap/meson.build
@@ -23,14 +23,14 @@ libdrm_omap = shared_library(
   [files('omap_drm.c'), config_file],
   include_directories : [inc_root, inc_drm],
   c_args : libdrm_c_args,
-  link_with : libdrm,
-  dependencies : [dep_pthread_stubs, dep_atomic_ops],
+  dependencies : [dep_pthread_stubs, dep_atomic_ops, ext_libdrm],
   version : '1.0.0',
   install : true,
 )
 
 ext_libdrm_omap = declare_dependency(
-  link_with : [libdrm, libdrm_omap],
+  link_with : [libdrm_omap],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
diff --git a/radeon/meson.build b/radeon/meson.build
index ca128329..76aa274d 100644
--- a/radeon/meson.build
+++ b/radeon/meson.build
@@ -30,14 +30,14 @@ libdrm_radeon = shared_library(
   ],
   c_args : libdrm_c_args,
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
-  dependencies : [dep_pthread_stubs, dep_atomic_ops],
+  dependencies : [dep_pthread_stubs, dep_atomic_ops, ext_libdrm],
   version : '1.0.1',
   install : true,
 )
 
 ext_libdrm_radeon = declare_dependency(
-  link_with : [libdrm, libdrm_radeon],
+  link_with : [libdrm_radeon],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
diff --git a/tegra/meson.build b/tegra/meson.build
index 88613b9c..b7537a39 100644
--- a/tegra/meson.build
+++ b/tegra/meson.build
@@ -22,15 +22,15 @@ libdrm_tegra = shared_library(
   'drm_tegra',
   [files('tegra.c'), config_file],
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
-  dependencies : [dep_pthread_stubs, dep_atomic_ops],
+  dependencies : [dep_pthread_stubs, dep_atomic_ops, ext_libdrm],
   c_args : libdrm_c_args,
   version : '0.0.0',
   install : true,
 )
 
 ext_libdrm_tegra = declare_dependency(
-  link_with : [libdrm, libdrm_tegra],
+  link_with : [libdrm_tegra],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
diff --git a/tests/amdgpu/meson.build b/tests/amdgpu/meson.build
index 4dfa5c83..7c1935e3 100644
--- a/tests/amdgpu/meson.build
+++ b/tests/amdgpu/meson.build
@@ -26,9 +26,9 @@ if dep_cunit.found()
       'vce_tests.c', 'uvd_enc_tests.c', 'vcn_tests.c', 'deadlock_tests.c',
       'vm_tests.c', 'ras_tests.c', 'syncobj_tests.c',
     ),
-    dependencies : [dep_cunit, dep_threads, dep_atomic_ops],
+    dependencies : [dep_cunit, dep_threads, dep_atomic_ops, ext_libdrm],
     include_directories : [inc_root, inc_drm, include_directories('../../amdgpu')],
-    link_with : [libdrm, libdrm_amdgpu],
+    link_with : [libdrm_amdgpu],
     install : with_install_tests,
   )
 endif
diff --git a/tests/etnaviv/meson.build b/tests/etnaviv/meson.build
index 8b4a3cfb..51ecb471 100644
--- a/tests/etnaviv/meson.build
+++ b/tests/etnaviv/meson.build
@@ -24,7 +24,8 @@ etnaviv_2d_test = executable(
   'etnaviv_2d_test',
   files('etnaviv_2d_test.c', 'write_bmp.c'),
   include_directories : inc_etnaviv_tests,
-  link_with : [libdrm, libdrm_etnaviv],
+  link_with : [libdrm_etnaviv],
+  dependencies : [ext_libdrm],
   install : with_install_tests,
 )
 
@@ -32,7 +33,8 @@ etnaviv_cmd_stream_test = executable(
   'etnaviv_cmd_stream_test',
   files('etnaviv_cmd_stream_test.c'),
   include_directories : inc_etnaviv_tests,
-  link_with : [libdrm, libdrm_etnaviv],
+  link_with : [libdrm_etnaviv],
+  dependencies : [ext_libdrm],
   install : with_install_tests,
 )
 
@@ -40,6 +42,7 @@ etnaviv_bo_cache_test = executable(
   'etnaviv_bo_cache_test',
   files('etnaviv_bo_cache_test.c'),
   include_directories : inc_etnaviv_tests,
-  link_with : [libdrm, libdrm_etnaviv],
+  link_with : [libdrm_etnaviv],
+  dependencies : [ext_libdrm],
   install : with_install_tests,
 )
diff --git a/tests/exynos/meson.build b/tests/exynos/meson.build
index 3a048e8a..57895598 100644
--- a/tests/exynos/meson.build
+++ b/tests/exynos/meson.build
@@ -27,8 +27,8 @@ if with_libkms
     c_args : libdrm_c_args,
     include_directories : [inc_root, inc_drm, inc_exynos,
                            include_directories('../../libkms')],
-    link_with : [libdrm, libkms, libdrm_exynos],
-    dependencies : dep_threads,
+    link_with : [libkms, libdrm_exynos],
+    dependencies : [dep_threads, ext_libdrm],
     install : with_install_tests,
   )
 endif
@@ -38,8 +38,8 @@ exynos_fimg2d_perf = executable(
   files('exynos_fimg2d_perf.c'),
   c_args : libdrm_c_args,
   include_directories : [inc_root, inc_drm, inc_exynos],
-  link_with : [libdrm, libdrm_exynos],
-  dependencies : dep_threads,
+  link_with : [libdrm_exynos],
+  dependencies : [dep_threads, ext_libdrm],
   install : with_install_tests,
 )
 
@@ -48,7 +48,7 @@ exynos_fimg2d_event = executable(
   files('exynos_fimg2d_event.c'),
   c_args : libdrm_c_args,
   include_directories : [inc_root, inc_drm, inc_exynos],
-  link_with : [libdrm, libdrm_exynos],
-  dependencies : dep_threads,
+  link_with : [libdrm_exynos],
+  dependencies : [dep_threads, ext_libdrm],
   install : with_install_tests,
 )
diff --git a/tests/kms/meson.build b/tests/kms/meson.build
index 91371aa0..fd5aaa06 100644
--- a/tests/kms/meson.build
+++ b/tests/kms/meson.build
@@ -26,7 +26,7 @@ libkms_test = static_library(
     'libkms-test-plane.c', 'libkms-test-screen.c',
   ),
   include_directories : [inc_root, inc_tests, inc_drm],
-  link_with : libdrm,
+  dependencies : [ext_libdrm],
   c_args : libdrm_c_args,
 )
 
diff --git a/tests/kmstest/meson.build b/tests/kmstest/meson.build
index 4fb870f9..5b9e7a08 100644
--- a/tests/kmstest/meson.build
+++ b/tests/kmstest/meson.build
@@ -25,6 +25,7 @@ kmstest = executable(
   include_directories : [
     inc_root, inc_tests, include_directories('../../libkms'), inc_drm,
   ],
-  link_with : [libutil, libkms, libdrm],
+  link_with : [libutil, libkms],
+  dependencies : [ext_libdrm],
   install : with_install_tests,
 )
diff --git a/tests/meson.build b/tests/meson.build
index 196edbfa..50a07000 100644
--- a/tests/meson.build
+++ b/tests/meson.build
@@ -52,7 +52,7 @@ drmsl = executable(
   'drmsl',
   files('drmsl.c'),
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
+  dependencies : [ext_libdrm],
   c_args : libdrm_c_args,
 )
 
@@ -60,7 +60,7 @@ hash = executable(
   'hash',
   files('hash.c'),
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
+  dependencies : [ext_libdrm],
   c_args : libdrm_c_args,
 )
 
@@ -68,7 +68,7 @@ drmdevice = executable(
   'drmdevice',
   files('drmdevice.c'),
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
+  dependencies : [ext_libdrm],
   c_args : libdrm_c_args,
   install : with_install_tests,
 )
diff --git a/tests/modeprint/meson.build b/tests/modeprint/meson.build
index 0801808a..067b18ab 100644
--- a/tests/modeprint/meson.build
+++ b/tests/modeprint/meson.build
@@ -23,7 +23,7 @@ modeprint = executable(
   files('modeprint.c'),
   c_args : libdrm_c_args,
   include_directories : [inc_root, inc_tests, inc_drm],
-  link_with : [libdrm, libutil],
-  dependencies : dep_threads,
+  link_with : [libutil],
+  dependencies : [dep_threads, ext_libdrm],
   install : with_install_tests,
 )
diff --git a/tests/modetest/meson.build b/tests/modetest/meson.build
index 23d84a1d..3b5039fa 100644
--- a/tests/modetest/meson.build
+++ b/tests/modetest/meson.build
@@ -23,7 +23,7 @@ modetest = executable(
   files('buffers.c', 'cursor.c', 'modetest.c'),
   c_args : [libdrm_c_args, '-Wno-pointer-arith'],
   include_directories : [inc_root, inc_tests, inc_drm],
-  dependencies : [dep_threads, dep_cairo],
-  link_with : [libdrm, libutil],
+  dependencies : [dep_threads, dep_cairo, ext_libdrm],
+  link_with : [libutil],
   install : with_install_tests,
 )
diff --git a/tests/nouveau/meson.build b/tests/nouveau/meson.build
index ca4d44f0..c64802c6 100644
--- a/tests/nouveau/meson.build
+++ b/tests/nouveau/meson.build
@@ -21,9 +21,9 @@
 threaded = executable(
   'threaded',
   files('threaded.c'),
-  dependencies : [dep_dl, dep_threads],
+  dependencies : [dep_dl, dep_threads, ext_libdrm],
   include_directories : [inc_root, inc_drm, include_directories('../../nouveau')],
-  link_with : [libdrm, libdrm_nouveau],
+  link_with : [libdrm_nouveau],
   c_args : libdrm_c_args,
 )
 
diff --git a/tests/proptest/meson.build b/tests/proptest/meson.build
index 9c87965a..b5a11a43 100644
--- a/tests/proptest/meson.build
+++ b/tests/proptest/meson.build
@@ -23,6 +23,7 @@ proptest = executable(
   files('proptest.c'),
   c_args : libdrm_c_args,
   include_directories : [inc_root, inc_tests, inc_drm],
-  link_with : [libdrm, libutil],
+  link_with : [libutil],
+  dependencies : [ext_libdrm],
   install : with_install_tests,
 )
diff --git a/tests/radeon/meson.build b/tests/radeon/meson.build
index bb345b73..33c3c68a 100644
--- a/tests/radeon/meson.build
+++ b/tests/radeon/meson.build
@@ -22,6 +22,6 @@ radeon_ttm = executable(
   'radeon_ttm',
   files('rbo.c', 'radeon_ttm.c'),
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
+  dependencies : [ext_libdrm],
   c_args : libdrm_c_args,
 )
diff --git a/tests/tegra/meson.build b/tests/tegra/meson.build
index 4f8c54f4..f1e4c30d 100644
--- a/tests/tegra/meson.build
+++ b/tests/tegra/meson.build
@@ -23,5 +23,6 @@ openclose = executable(
   files('openclose.c'),
   include_directories : [inc_root, inc_drm, include_directories('../../tegra')],
   c_args : libdrm_c_args,
-  link_with : [libdrm, libdrm_tegra],
+  link_with : [libdrm_tegra],
+  dependencies : [ext_libdrm],
 )
diff --git a/tests/util/meson.build b/tests/util/meson.build
index 7fa1a4b7..488cc6c9 100644
--- a/tests/util/meson.build
+++ b/tests/util/meson.build
@@ -23,6 +23,6 @@ libutil = static_library(
   'util',
   [files('format.c', 'kms.c', 'pattern.c'), config_file],
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
+  dependencies : [ext_libdrm],
   dependencies : dep_cairo
 )
diff --git a/tests/vbltest/meson.build b/tests/vbltest/meson.build
index 6339feba..e6305728 100644
--- a/tests/vbltest/meson.build
+++ b/tests/vbltest/meson.build
@@ -23,6 +23,7 @@ vbltest = executable(
   files('vbltest.c'),
   c_args : libdrm_c_args,
   include_directories : [inc_root, inc_tests, inc_drm],
-  link_with : [libdrm, libutil],
+  link_with : [libutil],
+  dependencies : [ext_libdrm],
   install : with_install_tests,
 )
